define("format_multitopic/courseformat/contenttabs/tabtree",["exports","core/reactive","core_courseformat/courseeditor","format_multitopic/courseformat/contenttabs/tab","core/templates"],(function(_exports,_reactive,_courseeditor,_tab,_templates){function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}
/**
   * Course section tabs updater.
   *
   * @module     format_multitopic/courseformat/contenttabs/tabtree
   * @class      format_multitopic/courseformat/contenttabs/tabtree
   * @copyright  2022 Jeremy FitzPatrick and Te Wānanga o Aotearoa
   * @copyright  2023 James Calder and Otago Polytechnic
   * @copyright  based on work by 2021 Ferran Recio <ferran@moodle.com>
   * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
   */Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0,_tab=_interopRequireDefault(_tab),_templates=_interopRequireDefault(_templates);class Component extends _reactive.BaseComponent{create(){this.name="contenttabs",this.selectors={TAB:"ul:first-of-type li",CHILDTAB:"ul:nth-child(2) li",SECTION_ITEM:"a.nav-link"},this.classes={ACTIVETAB:"active"},this.tabs={},this.childtabs={},this.activetab=[null,null]}static init(target){return new this({element:document.getElementById(target),reactive:(0,_courseeditor.getCurrentCourseEditor)()})}stateReady(){this._indexContents()}getWatchers(){return[{watch:"course.sectionlist:updated",handler:this._refreshCourseSectionTabs}]}async _refreshCourseSectionTabs(_ref){var _element$firstsection,_element$secondsectio;let{element:element}=_ref;const activeTab1=this.reactive.get("section",this.activetab[1]);let newActiveTab0id=activeTab1.levelsan>=1?activeTab1.parentid:activeTab1.id;if(newActiveTab0id!=this.activetab[0]){let section=this.reactive.get("section",this.activetab[0]),anchor=this.element.querySelector('ul:first-of-type div[data-itemid="'+this.activetab[0]+'"]').parentElement;anchor.classList.remove("active"),anchor.href=section.sectionurl.replace("&amp;","&"),this.activetab[0]=newActiveTab0id,anchor=this.element.querySelector('ul:first-of-type div[data-itemid="'+this.activetab[0]+'"]').parentElement,anchor.classList.add("active"),anchor.removeAttribute("href");const addAnchor=this.element.querySelector("ul:nth-of-type(2) li:last-of-type a"),addLink=addAnchor.href.replace(/&insertparentid=\d+/,"&insertparentid="+this.activetab[0]);addAnchor.setAttribute("href",addLink)}const toptabslist=null!==(_element$firstsection=element.firstsectionlist)&&void 0!==_element$firstsection?_element$firstsection:[],childtabslist=null!==(_element$secondsectio=element.secondsectionlist)&&void 0!==_element$secondsectio?_element$secondsectio:[];let toptabs=this.element.querySelector("ul:first-of-type");await this._fixOrder(toptabs,toptabslist,this.selectors.TAB,0,childtabslist[this.activetab[0]].length>1);let childtabs=this.element.querySelector("ul:nth-of-type(2)");childtabs&&await this._fixOrder(childtabs,childtabslist[this.activetab[0]],this.selectors.CHILDTAB,1,!1),this._indexContents()}_indexContents(){this._scanIndex(this.selectors.TAB,this.tabs,(item=>new _tab.default(item)),0),this._scanIndex(this.selectors.CHILDTAB,this.childtabs,(item=>new _tab.default(item)),1)}_scanIndex(selector,index,creationhandler,level){this.getElements("".concat(selector,":not([data-indexed])")).forEach((item=>{var _item$dataset;if(null==item||null===(_item$dataset=item.dataset)||void 0===_item$dataset||!_item$dataset.id)return;void 0!==index[item.dataset.id]&&index[item.dataset.id].unregister(),index[item.dataset.id]=creationhandler({...this,element:item}),-1!==item.querySelector("a").classList.value.indexOf(this.classes.ACTIVETAB)&&(level<=0&&(this.activetab[0]=item.dataset.id),this.activetab[1]=item.dataset.id),item.dataset.indexed=!0}))}async _fixOrder(container,neworder,selector,level,hassubtree){if(!neworder.length)return container.classList.add("hidden"),void(container.innerHTML="");container.classList.remove("hidden");for(const[index,itemid]of Object.entries(neworder)){const section=this.reactive.get("section",itemid),visible=(section.visible&&section.available||0==section.section)&&(neworder.length>1||hassubtree),current=null!=section.currentnestedlevel&&section.currentnestedlevel>=level;let item=this.getElement(selector,itemid);if(null===item){let data={sectionid:itemid,level:level,active:0,inactive:0,link:[{link:section.sectionurl}],title:section.name,text:'<div class="tab_content'+(visible?"":" dimmed")+(current?" marker":"")+'" data-itemid="'+section.id+'">'+section.title+"</div>"};item=document.createElement("li"),container.insertBefore(item,container.lastElementChild);let html=await _templates.default.render("format_multitopic/courseformat/contenttabs/tab",data);item=_templates.default.replaceNode(item,html,"")[0]}const content=item.querySelector("div.tab_content");content&&content.classList.contains("dimmed")==visible&&(visible?content.classList.remove("dimmed"):content.classList.add("dimmed")),content&&content.classList.contains("marker")!=current&&(current?content.classList.add("marker"):content.classList.remove("marker"));const currentitem=container.children[index];if(void 0===currentitem)return void container.append(item);currentitem!==item&&container.insertBefore(item,currentitem)}for(;container.children.length>neworder.length+1;)container.removeChild(container.lastElementChild.previousSibling)}}return _exports.default=Component,_exports.default}));

//# sourceMappingURL=tabtree.min.js.map